/*-] --
description: Valid PrivateName as private setter (multiple fields definitions)
esid: prod-FieldDefinition
includes: [propertyHelper.js]
info: |
    ClassElement :
      set ClassElementName ( PropertySetParameterList ) { FunctionBody }

    ClasElementName :
      PropertyName
      PrivateName

    PrivateName ::
      # IdentifierName
    IdentifierName ::
      IdentifierStart

    IdentifierStart ::
      $
      _
      \ UnicodeEscapeSequence

    IdentifierPart::
      $

    UnicodeIDContinue::
      any Unicode code point with the Unicode property "ID_Continue"

    NOTE 3

---*/

class C {
  foo = "foobar";
  m() { return 42 }
  set #$(value) {
    this.#$_ = value;
  }
  set #_(value) {
    this.#__ = value;
  }
  set #\u{6F}(value) {
  }
  set #\u2118(value) {
    this.#\u2118_ = value;
  }
  set #ZW_\u200C_NJ(value) {
    this.#ZW_\u200C_NJ_ = value;
  }
  set #ZW_\u200D_J(value) {
    this.#ZW_\u200D_J_ = value;
  }
  m2() { return 39 }
  $(value) {
    this.#$ = value;
    return this.#$_;
  }
  _(value) {
    this.#_ = value;
  }
  \u{6F}(value) {
    this.#\u{6F} = value;
    return this.#\u{6F}_;
  }
  \u2118(value) {
    this.#\u2118 = value;
    return this.#\u2118_;